# encoding : UTF-8

DDDS = {
  '11' => { ninth_digit: true,  state: 'SP', region: 'Região Metropolitana de São Paulo.' },
  '12' => { ninth_digit: true,  state: 'SP', region: 'São José dos Campos e Região.' },
  '13' => { ninth_digit: true,  state: 'SP', region: 'Região Metropolitana da Baixada Santista.' },
  '14' => { ninth_digit: true,  state: 'SP', region: 'Bauru, Jaú, Marília, Botucatu e Região.' },
  '15' => { ninth_digit: true,  state: 'SP', region: 'Sorocaba e Região.' },
  '16' => { ninth_digit: true,  state: 'SP', region: 'Ribeirão Preto, São Carlos, Araraquara e Região.' },
  '17' => { ninth_digit: true,  state: 'SP', region: 'São José do Rio Preto e Região.' },
  '18' => { ninth_digit: true,  state: 'SP', region: 'Presidente Prudente, Araçatuba e Região.' },
  '19' => { ninth_digit: true,  state: 'SP', region: 'Região Metropolitana de Campinas.' },
  '21' => { ninth_digit: true,  state: 'RJ', region: 'Região Metropolitana do Rio de Janeiro.' },
  '22' => { ninth_digit: true,  state: 'RJ', region: 'Campos dos Goytacazes e Região.' },
  '24' => { ninth_digit: true,  state: 'RJ', region: 'Volta Redonda, Petrópolis e Região.' },
  '27' => { ninth_digit: true,  state: 'ES', region: 'Região Metropolitana de Vitória.' },
  '28' => { ninth_digit: true,  state: 'ES', region: 'Cachoeiro de Itapemirim e Região.' },
  '31' => { ninth_digit: false, state: 'MG', region: 'Região Metropolitana de Belo Horizonte.' },
  '32' => { ninth_digit: false, state: 'MG', region: 'Juiz de Fora e Região.' },
  '33' => { ninth_digit: false, state: 'MG', region: 'Governador Valadares e Região.' },
  '34' => { ninth_digit: false, state: 'MG', region: 'Uberlândia e região.' },
  '35' => { ninth_digit: false, state: 'MG', region: 'Poços de Caldas, Pouso Alegre, Varginha e Região.' },
  '37' => { ninth_digit: false, state: 'MG', region: 'Divinópolis, Itaúna e Região.' },
  '38' => { ninth_digit: false, state: 'MG', region: 'Montes Claros e Região.' },
  '41' => { ninth_digit: false, state: 'PR', region: 'Região Metropolitana de Curitiba.' },
  '42' => { ninth_digit: false, state: 'PR', region: 'Ponta Grossa e Região.' },
  '43' => { ninth_digit: false, state: 'PR', region: 'Londrina e Região.' },
  '44' => { ninth_digit: false, state: 'PR', region: 'Maringá e Região.' },
  '45' => { ninth_digit: false, state: 'PR', region: 'Cascavel e Região.' },
  '46' => { ninth_digit: false, state: 'PR', region: 'Francisco Beltrão, Pato Branco e Região.' },
  '47' => { ninth_digit: false, state: 'SC', region: 'Joinville, Blumenau, Balneário Camboriú e Região.' },
  '48' => { ninth_digit: false, state: 'SC', region: 'Região Metropolitana de Florianópolis e Criciúma.' },
  '49' => { ninth_digit: false, state: 'SC', region: 'Chapecó, Lages e Região.' },
  '51' => { ninth_digit: false, state: 'RS', region: 'Região Metropolitana de Porto Alegre.' },
  '53' => { ninth_digit: false, state: 'RS', region: 'Pelotas e Região.' },
  '54' => { ninth_digit: false, state: 'RS', region: 'Caxias do Sul e Região.' },
  '55' => { ninth_digit: false, state: 'RS', region: 'Santa Maria e Região.' },
  '61' => { ninth_digit: false, state: 'DF', region: 'Brasília e Região.' },
  '62' => { ninth_digit: false, state: 'GO', region: 'Região Metropolitana de Goiânia.' },
  '63' => { ninth_digit: false, state: 'TO', region: 'Todos os municípios do estado.' },
  '64' => { ninth_digit: false, state: 'GO', region: 'Rio Verde e Região.' },
  '65' => { ninth_digit: false, state: 'MT', region: 'Região Metropolitana de Cuiabá.' },
  '66' => { ninth_digit: false, state: 'MT', region: '' },
  '67' => { ninth_digit: false, state: 'MS', region: 'Todos os municípios do estado.' },
  '68' => { ninth_digit: false, state: 'AC', region: 'Todos os municípios do estado.' },
  '69' => { ninth_digit: false, state: 'RO', region: 'Todos os municípios do estado.' },
  '71' => { ninth_digit: false, state: 'BA', region: 'Região Metropolitana de Salvador.' },
  '73' => { ninth_digit: false, state: 'BA', region: 'Itabuna, Ilhéus e Região.' },
  '74' => { ninth_digit: false, state: 'BA', region: 'Juazeiro e Região.' },
  '75' => { ninth_digit: false, state: 'BA', region: 'Feira de Santana e Região.' },
  '77' => { ninth_digit: false, state: 'BA', region: 'Vitória da Conquista e Região.' },
  '79' => { ninth_digit: false, state: 'SE', region: 'Todos os municípios do estado.' },
  '81' => { ninth_digit: false, state: 'PE', region: 'Região Metropolitana de Recife.' },
  '82' => { ninth_digit: false, state: 'AL', region: 'Todos os municípios do estado.' },
  '83' => { ninth_digit: false, state: 'PB', region: 'Todos os municípios do estado.' },
  '84' => { ninth_digit: false, state: 'RN', region: 'Todos os municípios do estado.' },
  '85' => { ninth_digit: false, state: 'CE', region: 'Região Metropolitana de Fortaleza.' },
  '86' => { ninth_digit: false, state: 'PI', region: 'Região de Teresina.' },
  '87' => { ninth_digit: false, state: 'PE', region: 'Região de Petrolina.' },
  '88' => { ninth_digit: false, state: 'CE', region: 'Região de Juazeiro do Norte.' },
  '89' => { ninth_digit: false, state: 'PI', region: 'Região de Picos e Floriano.' },
  '91' => { ninth_digit: false, state: 'PA', region: 'Região Metropolitana de Belém.' },
  '92' => { ninth_digit: false, state: 'AM', region: 'Região de Manaus.' },
  '93' => { ninth_digit: false, state: 'PA', region: 'Região de Santarém.' },
  '94' => { ninth_digit: false, state: 'PA', region: 'Região de Marabá.' },
  '95' => { ninth_digit: false, state: 'RR', region: 'Todos os municípios do estado.' },
  '96' => { ninth_digit: false, state: 'AP', region: 'Todos os municípios do estado.' },
  '97' => { ninth_digit: false, state: 'AM', region: 'Região de Tefé e Coari.' },
  '98' => { ninth_digit: false, state: 'MA', region: 'Região Metropolitana de São Luís.' },
  '99' => { ninth_digit: false, state: 'MA', region: 'Região de Imperatriz.' }
}

band_A_and_B = (96..99).to_a + (91..94).to_a

MOBILE_BANDS = {
  #####################################################
  # STATE | BAND A and B | BAND D        | BAND E     #
  #####################################################
  'SP' => (band_A_and_B + (81..87).to_a + (88..89).to_a).uniq,
  'RJ' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'ES' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'MG' => (band_A_and_B + (87..88).to_a + (81..84).to_a).uniq,
  'PR' => (band_A_and_B + (87..88).to_a + (84..85).to_a).uniq,
  'SC' => (band_A_and_B + (87..88).to_a + (84..85).to_a).uniq,
  'RS' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'DF' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'GO' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'TO' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'MT' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'MS' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'AC' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'RO' => (band_A_and_B + (81..83).to_a + (84..85).to_a).uniq,
  'BA' => (band_A_and_B + (87..88).to_a + (81..83).to_a).uniq,
  'SE' => (band_A_and_B + (87..88).to_a + (81..83).to_a).uniq,
  'PE' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'AL' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'PB' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'RN' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'CE' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'PI' => (band_A_and_B + (87..88).to_a + (80..89).to_a).uniq,
  'PA' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'AM' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'RR' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'AP' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq,
  'MA' => (band_A_and_B + (87..88).to_a + (80..83).to_a).uniq
}

MOBILE_SPECIAL_CASES_FIRST_2_DIGITS = {
  'SP' => [76, 89, 91, 92, 93, 94, 71, 72, 73, 74, 75, 95, 65, 68, 80, 99].uniq,
  'RJ' => [74, 75, 76, 71, 72, 95, 84, 85, 86, 89].uniq,
  'ES' => [],
  'MG' => [85, 86, 89, 96].uniq, 
  'PR' => [81].uniq,
  'SC' => [],
  'RS' => [95].uniq,
  'DF' => [86, 99].uniq,
  'GO' => [86, 99].uniq,
  'TO' => [86, 99].uniq,
  'MT' => [86, 99].uniq,
  'MS' => [86, 99].uniq,
  'AC' => [86, 99].uniq,
  'RO' => [86, 99].uniq,
  'BA' => [86].uniq,
  'SE' => [86].uniq,
  'PE' => [88, 84, 85, 86].uniq,
  'AL' => [88, 84, 85, 86].uniq,
  'PB' => [88, 84, 85, 86].uniq,
  'RN' => [88, 84, 85, 86].uniq,
  'CE' => [88, 84, 85, 86].uniq,
  'PI' => [88, 84, 85, 86].uniq,
  'PA' => [84].uniq,
  'AM' => [84].uniq,
  'RR' => [84].uniq,
  'AP' => [84].uniq,
  'MA' => [84].uniq 
}

MOBILE_SPECIAL_CASES_FIRST_4_DIGITS = {
  'SP' => ((6340..6369).to_a + (7011..7051).to_a + (7950..7967).to_a + (6310..6339).to_a + (6589..6599).to_a + (7052..7062).to_a + (8800..8899).to_a + (6057..6060).to_a + (6193..6199).to_a + (6370..6499).to_a + [7099] + (6100..6193).to_a + [6299] + (6651..6799).to_a + [6999] + (7971..7999).to_a + (8814..8899).to_a + (7900..7949).to_a + (5700..5768).to_a + (5787..5799).to_a + (5475..5499).to_a + (5472..5474).to_a + (5769..5786).to_a).uniq,
  'RJ' => [],
  'ES' => [],
  'MG' => ((9960..9979).to_a + (9991..9999).to_a).uniq,
  'PR' => ((9941..9998).to_a).uniq,
  'SC' => [],
  'RS' => ((9911..9939).to_a).uniq,
  'DF' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'GO' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'TO' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'MT' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'MS' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'AC' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'RO' => ((9551..9559).to_a + (9981..9989).to_a).uniq,
  'BA' => [],
  'SE' => [],
  'PE' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'AL' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'PB' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'RN' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'CE' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'PI' => ((8719..8721).to_a + (8100..82000).to_a).uniq,
  'PA' => [],
  'AM' => [],
  'RR' => [],
  'AP' => [],
  'MA' => [] 
}

MOBILE_SME_FIRST_2_DIGITS = {
  'SP' => [],
  'RJ' => [70, 77, 78].uniq,
  'ES' => [70, 77, 78].uniq,
  'MG' => [], 
  'PR' => [],
  'SC' => [],
  'RS' => [],
  'DF' => [],
  'GO' => [],
  'TO' => [],
  'MT' => [],
  'MS' => [],
  'AC' => [],
  'RO' => [],
  'BA' => [],
  'SE' => [],
  'PE' => [],
  'AL' => [],
  'PB' => [],
  'RN' => [],
  'CE' => [],
  'PI' => [],
  'PA' => [],
  'AM' => [],
  'RR' => [],
  'AP' => [],
  'MA' => []
}
